---
eleventyExcludeFromCollections: true
title: "おこげ倶楽部自宅サーバについて"
description: "ocoge.club は Orange Pi 自宅サーバにてホスティングされています。Webサーバ、メールサーバ、Git サーバ稼働中。"
date: 2022-05-07
thumb: "opi-server.webp"
tags:
    - 技術情報
---

ocoge.club は Orange Pi 自宅サーバ（上写真）にてホスティングされています。現在 Webサーバ、メールサーバ、Git サーバが稼働しています。数千円で購入できる手のひらサイズのシングルボードコンピュータと3千円程度のSSDを使ってなかなか充実したネットサービスごっこwができます。

{% talkicon_l {img: 'tama.webp', name: 'タマちー'} %}{% says_l %}
「おこげ俱楽部」は、軽量多目的 ~~Raspberry Pi~~ {% link_new {uri: 'http://www.orangepi.org/',title: 'Orange Pi'} %}Orange Pi{% endlink_new %} サーバーとして絶賛改装中です...。
{% endsays_l %}
{% talkicon_r {img: 'mimmy.webp', name: 'ミミィ'} %}{% says_r %}
市場でラズパイが枯渇している関係で、サーバのハードウェアを 4B(4GB) から、現状最も手に入りやすい中華~~パチモン~~ <span title="シングルボードコンピュータ">SBC</span> の Orange Pi に変更したのよね！軽量化のために{% span "mfy" %}{% link_new {uri: "https://ja.wordpress.org", title: "シェア世界一の CMS"} %}WordPress{% endlink_new %}{% endspan %} をやめて {% span "mfg" %}{% link_new {uri: "https://jamstack.org", title: "ちょっと何言ってるか分からない"} %}Jamstack{% endlink_new %}{% endspan %} にするとかの対応中ヨ！
{% endsays_r %}
{% talkicon_l {img: 'tama.webp', name: ''} %}{% think_l %}
らずぱい売ってない... 困る...
{% endthink_l %}
{% talkicon_r {img: 'mimmy.webp', name: ''} %}{% says_r %}
RSコンポーネンツの通販サイトに「11月入荷」とか書いてあるのよ！  
鬼も笑えないわ！！
{% endsays_r %}

## ハードウェア構成

- {% link_new {uri: 'http://www.orangepi.org/Orange%20Pi%203%20LTS/index.html',title: ''} %}Orange Pi 3 LTS{% endlink_new %}
- Crucial SSD 120GB 2.5インチ (CT120BX500SSD1JP)
- Salcar USB-C 2.5インチ SATA HDD/SSDケース

ケースは RPi 用を流用。ネジ穴が合わなかったので百均の耐震マットを小さく切って貼り付け。  

## ソフトウェア構成

| 種類 | 名称 |
| --- | --- |
| OS | {% link_new {uri: 'http://www.orangepi.org/downloadresources/',title: ''} %}Orange Pi3 LTS Debian Buster Server{% endlink_new %} |
| Webサーバ | {% link_new {uri: 'https://nginx.org/en/',title: ''} %}Nginx{% endlink_new %} |
| サーバサイドインタプリタ | {% link_new {uri: 'https://www.php.net/',title: ''} %}PHP{% endlink_new %} |
| データベース | {% link_new {uri: 'https://www.sqlite.org/index.html',title: ''} %}SQLite3{% endlink_new %} |
| メールサーバ (MTA) | {% link_new {uri: 'http://www.postfix.org/',title: ''} %}Postfix{% endlink_new %} |
| Webメールクライアント | {% link_new {uri: 'https://www.rainloop.net/',title: ''} %}Rainloop{% endlink_new %} |
| POP/IMAP サーバ | {% link_new {uri: 'https://www.dovecot.org/',title: ''} %}Dovecot{% endlink_new %} |
| Git サーバ | {% link_new {uri: 'https://gitea.io/',title: ''} %}Gitea{% endlink_new %} |

このほか、スパムメール対策に {% link_new {uri: 'https://spamassassin.apache.org/',title: ''} %}SpamAssasin{% endlink_new %} であるとか証明書取得に {% link_new {uri: 'https://letsencrypt.org/ja/',title: ''} %}Let’s Encrypt (certbot){% endlink_new %} であるとか

## その他利用しているもの

独自ドメイン (ocoge.club)  
{% link_new {uri: 'https://www.mydns.jp/',title: ''} %}MyDNS{% endlink_new %}（無料ダイナミックDNS）  
インターネット接続回線（有線LANで接続）  
静的サイトジェネレータ {% link_new {uri: 'https://www.11ty.dev/',title: ''} %}11ty{% endlink_new %} 及びブログテーマ {% link_new {uri: 'https://github.com/dafiulh/vredeburg',title: ''} %}Vredeburg{% endlink_new %}

## 参考サイト

{% link_new {uri: 'https://samhobbs.co.uk/raspberry-pi-email-server',title: ''} %}Sam Hobbs | Raspberry Pi Email Server{% endlink_new %}  
英語でメールサーバのみの解説ではあるが、ステップごとにインストールや設定がうまくいっているかどうか確認を行うことができるようになっているため、長い作業の中でどこでミスをしたのか、または不具合が出ているのかがわかりやすい。また、設定をデフォルトから変更する箇所にそれぞれ設定の意味の説明があり、自分が何をしているのかがわかるため、ソフトウェアのアップデートで設定項目やその値に変更があり見本と齟齬が生じていても対処が容易である。わけもわからず言われた通り延々ソフトウェアのインストールと設定ファイルの書き換えを繰り返し、辟易しながら終わらせたものの結局動作せず問題のある個所も見当がつかないまま挫折、などという悲劇を起こしにくい、ナイスなサイト。

{% talkicon_l {img: 'tama.webp', name: ''} %}{% says_l %}
WordPress と NextCloud の運用をやめた理由は実は別にあったりする...
{% endsays_l %}
{% talkicon_r {img: 'mimmy.webp', name: ''} %}{% says_r %}
セキュリティアップデートが面倒だったのヨ！  
仕事でもないのにあんなのやってられないワ！！
{% endsays_r %}
