---
eleventyExcludeFromCollections: true
title: "『オコゲ』デスクトップ"
description: "Raspberry Pi デスクトップアプリ版『オコゲ』について"
date: 2022-06-13
thumb: "ogp_ocoge-desktop.webp"
tags:
    - オコゲ
    - デスクトップアプリ版
---

{% iconbox {
    iconclass: 'fa-solid fa-triangle-exclamation'
} %}
このページで紹介するアプリは、限定的な環境において使用することを前提として素人が趣味で開発しているもので、不特定多数の方々の利用を想定したものではありません。ご了承くださいませ。
{% endiconbox %}

{% talkicon_r {img: 'mimmy.webp', name: 'ミミィ'} %}{% says_r %}
要するにちゃんと動かなくても文句言うなってことネ！
{% endsays_r %}

{% talkicon_l {img: 'tama.webp', name: 'タマちー'} %}{% think_l %}
言い方・・・
{% endthink_l %}

## ダウンロードとインストール

{% link_new {uri: 'https://ocf.ltt.jp/',title: ''} %}『オコゲ』ダウンロードページ{% endlink_new %}から最新版（最上部に表示されているもの）をダウンロードしてください。  
ターミナルから次のようにインストールします。

```bash
$ sudo apt install ./ocoge_x.x.x_arm64.deb
# x.x.x はバージョン番号
```

## アンインストール

ターミナルから次のように入力してください。

```bash
$ sudo apt remove ocoge
```

~/.config/ocoge に設定ファイルが残っていて気になる場合は手動で削除してください。

## 使い方

GPIO にアクセスするために、PIGPIO デーモンを起動しておきます。

```bash
$ sudo pigpiod
```

上記コマンドは、RPi を再起動するたびに実行する必要があります。  
サービスとして有効にするには上記コマンドの代わりに、以下を実行してください。

```bash
$ sudo systemctl enable pigpiod
$ sudo systemctl start pigpiod
```

『オコゲ』を実行するには、アプリケーションメニュー -> プログラミング -> ocoge で起動するか、ターミナルで ocoge と入力します。  
基本的な使用方法は体験版やプチレッスンのページをご確認ください。

{% blogcard {link:'http://localhost/2022-05-07_demo/'} %}

{% blogcard {link:'http://localhost/2022-05-14_petitlesson-01_typewriter-1/'} %}

## 制限・制約

『オコゲ』の動作には開発者都合によるいくつかの制限・制約があります。これらに関して今後の変更・改善は予定されておりません。

### I2C, シリアル接続は同時に１つまで

{% inlineimg {img: 'block_serial_open.webp',height: '32px'} %} 及び {% inlineimg {img: 'block_i2c_open.webp',height: '32px'} %} のブロックは同時に１つの機器にしか接続できません。例えば、次のように

{% centerimg 'block_i2c_twin.webp' %}
{% endcenterimg %}

のようなブロックを実行した場合、アドレス 1 のデバイスに接続する前にアドレス 0 のデバイスとは自動的に切断されます。

### センサー接続はそれぞれ同時に１つまで

センサーブロックは種類ごとにそれそれ１つまで接続可能です。例えば

{% centerimg 'block_i2c_mix.webp' %}
{% endcenterimg %}

は正常に動きますが、

{% centerimg 'block_bme280_twin.webp' %}
{% endcenterimg %}

は、アドレス 0x76 の機器への接続は自動的に切断され、0x77 への接続だけが残ります。

## Tips

### 安全な無限ループ

{% centerimg 'block_infinit_loop.webp' %}
{% endcenterimg %}

上記のような無限ループを作って実行すると『オコゲ』が操作を受け付けなくなります（ウィンドウ右上の[X]ボタンで『オコゲ』アプリ自体を終了することはできます）。これを避けるには、{% inlineimg {img: 'block_wait_zero.webp',height: '32px'} %} を使って次のようにします。

{% centerimg 'block_safe_loop.webp' %}
{% endcenterimg %}

このようにすることで、可能な限り早くループを回しつつ、ユーザ入力を受け付けるタイミングを確保することができます。

### I2C バスの変更

Raspberry Pi のデフォルトの I2C バス１（GPIO2-3）は内部で 1.8kΩ の抵抗によってプルアップされているため、プルアップ内蔵の I2C モジュールの一部が動作しない恐れがあります（{% link_new {uri: 'https://akizukidenshi.com/catalog/faq/goodsfaq.aspx?goods=K-06795',title: ''} %}例{% endlink_new %}）。  
実際やってみると大抵はそのままで問題なく動くのですが、内部プルアップされていないピンに I2C を割り当てることで不具合をあらかじめ回避することもできます。当サイトではバス６（GPIO22-23）を使用しています。

I2Cバス６を有効化するには、/boot/config.txt に dtoverlay=i2c6,pins_22_23 を追記して再起動します。

```bash
$ echo 'dtoverlay=i2c6,pins_22_23' | sudo tee -a /boot/config.txt
$ sudo reboot
```

※ I2C バス１を使用する場合は、「Raspberry Pi の設定」や raspi-config で「I2C を有効」に設定してください。

●『オコゲ』の設定

ワークスペース画面でキーボードから「Shift+Ctrl+M」を入力すると、隠されていたメニューバーが表示されます。「Settings」-> 「i2c bus」->「6」を選択し、I2C バスを変更します。

{% centerimg 'i2c-settings.webp' %}
{% endcenterimg %}

もう一度「Shift+Ctrl+M」を入力するとメニューバーが隠れます。


## ソースコード

ソースコードは {% link_new {uri: 'https://git.ocoge.club/ocoge.club/ocoge',title: ''} %}ocogIt{% endlink_new %} で公開しています。