---
title: "ジェスチャーセンサ PAJ7620 を試す"
description: "ちょっと楽しそうなハンドジェスチャセンサモジュール PAJ7620 を入手したので、『オコゲ』を使って遊んでみました。"
date: 2022-08-03
thumb: "ogp_paj7620.webp"
tags:
    - オコゲ
    - デスクトップアプリ版
    - センサー
    - 動画
---

{% simplebox 'box_stripe' %}ちょっと楽しそうなハンドジェスチャセンサモジュール PAJ7620 を入手したので、『オコゲ』を使って遊んでみました。{% endsimplebox %}

## PAJ7620 概要

- 9種類のジェスチャーを認識（上下左右、前後、時計回り・反時計回り、波）
- I2C インターフェース
- 動作電圧：3.3V
- 検出範囲：5～10cm
- {% link_new {uri: 'https://wiki.seeedstudio.com/Grove-Gesture_v1.0/#resources',title: ''} %}データシート{% endlink_new %}

## 配線

{% floatbox {
    img: 'paj7620.webp',
    title: 'ジェスチャーセンサー配線',
    width: '200px',
    colortheme: 'silver'
} %}
<i class="fa-solid fa-magnifying-glass"></i> クリックで拡大
{% endfloatbox %}

VIN→3.3V  
GND→GND  
SDA→GPIO2  
SCL→GPIO3  
INT→オープン

## Raspberry Pi の設定

<span style="font-size: 20px; color: #ff0000"><i class="fab fa-raspberry-pi"></i></span>メニュー→設定→Raspberry Piの設定→「インターフェース」タブで I2C を有効にしておく

## 『オコゲ』プログラム

{% floatbox {
    img: 'gesture_blockprg.webp',
    title: '『オコゲ』ブロックプログラム',
    width: '400px',
    colortheme: 'silver'
} %}
<i class="fa-solid fa-magnifying-glass"></i> クリックで拡大
{% endfloatbox %}

### 動画サンプル

PAJ7620を『オコゲ』で使用している動画です。  
※ 古い動画なので現在の『オコゲ』とは見た目が色々と異なっています。ご了承ください。

{% youtube {
    videoid: '-JwvqsHIYU0'
} %}
ジェスチャーセンサ PAJ7620 を試す
{% endyoutube %}

いろいろ遊べそうな雰囲気。Raspberry Pi Zero をネットラジオ再生専用機にしたりしているので、ジェスチャ対応にしてみたら面白いかもしれない。

<span class="tsubuyaki">昔見たイギリス製SFテレビドラマ「SPACE: 1999」を思い出した。「The Last Enemy（邦題：宇宙戦艦ミサイル発射！）」というエピソードで、その宇宙戦艦「 サタゼウス 」のコントロールパネルがまさにこんな感じの非接触式ジェスチャ操作で、当時その未来的な雰囲気がチョーカッコイイと感じたのを覚えている。今見るとこれはこれで「レトロ未来感」が逆にカッコイイのだが。
関係ないけどサタゼウスの乗組員が全員女性（全員女性の惑星と全員男性の惑星が戦争しているという設定w）で、これまた{% link_new {uri: 'https://www.imdb.com/title/tt0706347/mediaviewer/rm1324681984',title: 'IMBD'} %}カッコイイ{% endlink_new %}のだった。リンク先の写真の直後、戦艦が爆破されてみんな死んじゃうけど。敵だったからネ</span>

